import{jsxs as t,jsx as i,Fragment as o}from"react/jsx-runtime";import{Card as r,Icon as e,Typography as n,Button as a}from"@equinor/eds-core-react";import{info_circle as l}from"@equinor/eds-icons";import{useTutorials as s,useTutorialStepImage as d}from"@equinor/subsurface-app-management";import{useTutorialHighlighting as m}from"../TutorialHighlightingProvider.js";import{TUTORIAL_HIGHLIGHT_ANIMATION_PROPS as h}from"../TutorialHighlightingProvider.constants.js";import{StepIndicator as c}from"./StepIndicator.js";import{elevation as p}from"../../../atoms/style/index.js";import{useReversedScrollY as g}from"../hooks/useReversedScrollY.js";import{motion as u,useTransform as f}from"framer-motion";import v,{css as b}from"styled-components";import{spacings as x}from"../../../atoms/style/spacings.js";import{colors as y}from"../../../atoms/style/colors.js";const $=v(u(r))`
  width: 360px;
  padding: ${x.medium};
  background: ${y.infographic.primary__moss_green_13.rgba};
  display: flex;
  flex-direction: column;
  gap: ${x.medium};
  transition:
    top 400ms,
    left 400ms;
  box-shadow: ${p.raised};
  pointer-events: auto;
  > header {
    display: flex;
    gap: ${x.small};
    align-items: center;
  }
  > img {
    max-height: 170px;
    object-fit: contain;
  }
  ${({$highlightingElement:t})=>t&&b`
      transform: translateX(-50%);
      &:before {
        z-index: -1;
        content: '';
        width: 32px;
        height: 26px;
        background: ${y.infographic.primary__moss_green_13.rgba};
        position: absolute;
        top: 0;
        left: 50%;
        transform: translate(-50%, 0) rotate(45deg);
      }
    `}
`,_=v.div`
  display: flex;
  justify-content: flex-end;
  gap: ${x.small};
  &:has(> :last-child:nth-child(3)) {
    > button:first-child {
      margin-right: auto;
    }
  }
`,k=({isHighlighting:r,id:p,top:u,left:v,width:b,height:x,name:k,steps:j})=>{const{customStepContent:C}=m(),{activeTutorial:S,activeStep:T,skipTutorial:w,startTutorial:E,goToNextStep:H,goToPreviousStep:P}=s(),{data:q}=d(S?.steps.at(T)?.imgUrl??void 0),I=g(),D=u&&x?u+x+16:void 0,N=v&&b?v+b/2:void 0,z=!!D&&!!N,A=f(I,(t=>z?t+D:null)),B=()=>{w(p)},F=()=>{E(p)};if(void 0!==T&&j[T].custom&&!C[j[T].id])throw new Error(`[TutorialHighlightingProvider]: Custom step content not found, tutorial ID: ${p}, step ID: ${j[T].id}`);return!z&&r?null:t($,S&&void 0!==T?{style:{position:z?"absolute":void 0,top:A,left:N},$highlightingElement:z,...h,children:[j[T].custom?C[j[T].id]:t(o,{children:[t("header",{children:[i(e,{data:l,color:y.interactive.primary__resting.rgba}),i(n,{variant:"h6",children:j[T]?.title})]}),i(n,{variant:"body_short",children:j[T]?.body}),q?i("img",{src:q,alt:j[T].title}):null]}),t(_,{children:[i(a,{variant:"outlined",disabled:0===T,onClick:P,children:"Back"}),i(a,{variant:"ghost",onClick:B,children:"Cancel"}),i(a,{onClick:H,children:T===j.length-1?"Finish":"Next"})]}),i(c,{stepAmount:j.length})]}:{style:{position:z?"absolute":void 0,top:A,left:N},$highlightingElement:z,...h,children:[t("header",{children:[i(e,{data:l,color:y.interactive.primary__resting.rgba}),i(n,{variant:"h6",children:k})]}),t(_,{children:[i(a,{variant:"ghost",onClick:B,children:"Skip"}),i(a,{onClick:F,children:"Start tour"})]})]})};export{k as TutorialPopover};
